//Bringing in the needed libraries
#include <LiquidCrystal.h>

//Declaring the pins in which each device is connected
int button = 5;

int LED9 = A0;
int LED5 = A1;
int LED8 = A2;
int LED4 = A3;
int LED7 = A4;
int LED6 = A5;
int LED3 = 6;
int LED1 = 4;
int LED2 = 3; 

const int rs = 8, E = 9, D4 = 10, D5 = 11, D6 = 12, D7 = 13;
LiquidCrystal lcd(rs, E, D4, D5, D6, D7);

//Declaring Global Variables
int light = 0;
int score = 0;

//Setting up the use for each device as in like if it will be used for input or output
void setup()
{
  lcd.begin(16, 2);
  lcd.print("Welcome to...");
  delay(2000);
  lcd.clear();
  lcd.print("ULTIMATE");
  lcd.setCursor(0, 1);
  lcd.print("Light Catcher");
  delay(2000);
  lcd.clear();
  lcd.print("Catch the");
  lcd.setCursor(0, 1);
  lcd.print("RED LED");
  delay(2000);
  lcd.clear();
  lcd.print("Good Luck!");
  delay(2000);
  lcd.clear();
  
  pinMode(6, INPUT);
  pinMode(4, INPUT);
  pinMode(3, INPUT);
  pinMode(5, INPUT);
}

//The void loop that keps a track of when the button is pressed
void buttonpress()
{
  if (digitalRead(button) == LOW) //the peice of code that actually detects the button push   
  {
    if (light == 1)
    {
      score++;
      lcd.clear();
      lcd.print("You caught");
      lcd.setCursor(0, 1);
  	  lcd.print("the RED LED");
      delay(2000);
      lcd.clear();
      lcd.print("GOOD JOB!");
      delay(2000);
      lcd.clear();
      if (score < 3)
      {
        lcd.clear();
        lcd.print("On to the");
        lcd.setCursor(0, 1);
  	  	lcd.print("NEXT LEVEL!");
      	delay(2000);
      	lcd.clear();
      }
    }
    else if (light == 2)
    {
      score = 0;
      lcd.clear();
      lcd.print("You caught");
      lcd.setCursor(0, 1);
  	  lcd.print("a GREEN LED");
      delay(2000);
      lcd.clear();
      lcd.print("Better luck");
      lcd.setCursor(0, 1);
  	  lcd.print("next time!");
      delay(2000);
      lcd.clear();
      lcd.print("Back to");
      lcd.setCursor(0, 1);
  	  lcd.print("LEVEL 1");
      delay(2000);
      lcd.clear();
    }
    else if (light == 3)
    {
      score = 0;
      lcd.clear();
      lcd.print("You caught");
      lcd.setCursor(0, 1);
  	  lcd.print("a YELLOW LED");
      delay(2000);
      lcd.clear();
      lcd.print("Better luck");
      lcd.setCursor(0, 1);
  	  lcd.print("next time!");
      delay(2000);
      lcd.clear();
      lcd.print("Back to");
      lcd.setCursor(0, 1);
  	  lcd.print("LEVEL 1");
      delay(2000);
      lcd.clear();
    }
  }
}


//Since each LED is wired into an input pin on the Arduino, I am able to keep track of the 
//LED blinking and then accordingly change the value of the 'light' variable to let the code know which LED is shining so it can display 
//that info to the user and let them know if they caught the RED LED or not
void lighttracker()
{
  buttonpress();
  
  if (digitalRead(LED9) == 1)
  {
    light = 2;
  }
  else if (digitalRead(LED8) == 1)
  {
    light = 3;
  }
  else if (digitalRead(LED7) == 1)
  {
    light = 2;
  }
  else if (digitalRead(LED6) == 1)
  {
    light = 3;
  }
  else if (digitalRead(LED5) == 1)
  {
    light = 1;
  }
  else if (digitalRead(LED4) == 1)
  {
    light = 3;
  }
  else if (digitalRead(LED3) == 1)
  {
    light = 2;
  }
  else if (digitalRead(LED2) == 1)
  {
    light = 3;
  }
  else if (digitalRead(LED1) == 1)
  {
    light = 2;
  }
  
  buttonpress();
}

//The actual loop that keeps all the void functions constantly being called so the code can keep working until the person catches the red LED three times in a row and wins the game
//After they have won the game, the code will exit out so it stops running
void loop()
{ 
  lighttracker();
  
  if (score == 0)
  {
   	lcd.setCursor(0, 1);
    lcd.print("LEVEL 1");
  }
  else if (score == 1)
  {
    lcd.setCursor(0, 1);
    lcd.print("LEVEL 2");
  }
  else if (score == 2)
  {
    lcd.setCursor(0, 1);
    lcd.print("LEVEL 3");
  }
  else if (score == 3)
  {
    lcd.print("GAME OVER");
    delay(2000);
    lcd.clear();
    lcd.print("CONGRATS");
    lcd.setCursor(0, 1);
    lcd.print("YOU WIN!");
    exit(0);
  }
}
